<?php

namespace Drupal\themespace\Annotation;

use Drupal\Component\Annotation\Plugin;

/**
 * Base plugin annotation for ProviderTypedPlugin classes.
 *
 * @see \Drupal\themespace\Annotation\ProviderTypedPluginInterface
 */
class ProviderTypedPlugin extends Plugin implements ProviderTypedPluginInterface {

  /**
   * {@inheritdoc}
   */
  public function getProviderType(): ?string {
    if (!empty($this->definition['providerType'])) {
      return $this->definition['providerType'];
    }
    return NULL;
  }

  /**
   * {@inheritdoc}
   */
  public function setProviderType(string $extensionType): void {
    if ($extensionType) {
      $this->definition['providerType'] = $extensionType;
    }
    else {
      unset($this->definition['providerType']);
    }
  }

}
